using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
 
namespace OlFoldersEvents
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("6BFB5E92-1CB4-4A10-9C74-51AF9DCF9531"), ProgId("OlFoldersEvents.AddinModule"), RunInstaller(true)]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule(System.ComponentModel.IContainer container)
        {
            // This call is required by the Component Designer
            container.Add(this);
            InitializeComponent();
 
            // TODO: Add any initialization after the InitializeComponent call
        }
 
        public AddinModule()
        {
            InitializeComponent();
        }
 
        // Add-in Module Implementation
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
			// 
			// AddinModule
			// 
			this.AddinName = "OlFoldersEvents";
			this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
			this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);
			this.AddinBeginShutdown += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinBeginShutdown);

		}
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

		private Outlook.MAPIFolder delFolder = null;
		private FoldersEvents_SinkHelper olFolderEvents;

		public Outlook.Application OutlookHost()
		{
			return (Outlook.Application)HostApplication;
		}

		private void AddinModule_AddinStartupComplete(object sender, System.EventArgs e)
		{
			Outlook.NameSpace oNameSpace = null;
			try
			{
				olFolderEvents = new FoldersEvents_SinkHelper(this);
				oNameSpace = OutlookHost().GetNamespace("MAPI");
				delFolder = oNameSpace.GetDefaultFolder(Outlook.OlDefaultFolders.olFolderDeletedItems);
				olFolderEvents.ConnectTo(delFolder);
			}
			finally
			{
				if (oNameSpace != null)
					Marshal.ReleaseComObject(oNameSpace);
			}
		}

		private void AddinModule_AddinBeginShutdown(object sender, System.EventArgs e)
		{
			if (olFolderEvents != null)
				olFolderEvents.Dispose();
			if (delFolder != null)
				Marshal.ReleaseComObject(delFolder);
		}
 
    }
}

